#include <Servo.h>

#define LED1_PIN 7
#define LED2_PIN 8
#define SPK_PIN 3

#define ECHO_PIN 12
#define TRIG_PIN 11

#define STATUS_MANUAL 0
#define STATUS_AUTO 1

int status = STATUS_MANUAL;

int x;
int y;

String inMovement = "0";

void setup() {
  Serial.begin(9600); 
  // PIN MODES
  pinMode(LED1_PIN, OUTPUT);  
  pinMode(LED2_PIN, OUTPUT); 
  pinMode(SPK_PIN, OUTPUT); 

  startIndicator();
}

void startIndicator(){
  for(int i = 0; i < 7; i++){
    digitalWrite(LED1_PIN, i%2 ? HIGH : LOW);
    digitalWrite(LED2_PIN, i%2 ? HIGH : LOW);
    if(i > 3) 
      playNote('C', 40);
    delay(80);
  }
}

String lastRequest;

void loop(){
  if(status == STATUS_MANUAL){
    String request = serialRead();
    boolean valid = handleCommand(request);

    if(request != "" && valid){
      lastRequest = request;
    }

    if(x == 0 && y == 0){
      inMovement = "0";
    } 
    else {
      inMovement = "1";
    }

    Serial.print("<Done:" + lastRequest + "|" + inMovement + ">");
  }
}

