#define LEFTSERVOPIN  10
#define RIGHTSERVOPIN  9

Servo leftServo; 
Servo rightServo; 
int speed = 100;

void attachServos(boolean action){
  if(action){
    leftServo.attach(LEFTSERVOPIN);    //attaches left servo
    rightServo.attach(RIGHTSERVOPIN);  //attaches right servo
  } 
  else {
    leftServo.detach(); 
    rightServo.detach(); 
    delay(50);
  }
}

void parseCoordinates(String joystickXY){
  int beginIdx = 0;
  int idx = joystickXY.indexOf(",");
  String arg;
  char charBuffer[16];
  while (idx != -1)
  {
    arg = joystickXY.substring(beginIdx, idx);
    arg.toCharArray(charBuffer, 16);
    // add error handling for atoi:
    x = atoi(charBuffer);
    beginIdx = idx + 1;
    idx = joystickXY.indexOf(",", beginIdx);
  }


  arg = joystickXY.substring(beginIdx);
  arg.toCharArray(charBuffer, 16);
  y = atoi(charBuffer);
}
int prevRotationL = 90;
int prevRotationR = 90;


void stopMovement(){
  if(inMovement == "1"){
    attachServos(false);
    x = 0;
    y = 0;
    prevRotationL = 90;
    prevRotationR = 90;
  }
}

void move(int x, int y){
  int speed = map(y, -90, 90,0,180);
  int direction = x;

  int rotationL = speed - direction;
  int rotationR = 180 - speed - direction;

  int signL = prevRotationL - rotationL > 0 ? -1 : 1;
  int signR = prevRotationR - rotationR > 0 ? -1 : 1;

  if(prevRotationL == 90 && prevRotationR == 90){
    attachServos(true);
  }

  // Switch speed gradually
  while(true){
    if(prevRotationL == rotationL && prevRotationR == rotationR){
      break;
    }
    leftServo.write(180 - prevRotationL);
    rightServo.write(180 - prevRotationR);
    if(prevRotationL != rotationL){
      prevRotationL = prevRotationL + 1 * signL;
    }
    if(prevRotationR != rotationR){
      prevRotationR = prevRotationR + 1 * signR;
    }
    delay(5);
  }
  if(prevRotationL == 90 && prevRotationR == 90){
    attachServos(false);
  }
}


