#define SOP '<'
#define EOP '>'

bool started = false;
bool ended = false;

char inData[80];
byte index;

String serialRead(){
  String data = "";
  char incomingByte;

  while(Serial.available()) {
    incomingByte = Serial.read();
    if(incomingByte == SOP)
    {
      started = true;
      ended = false;
    }
    else if(incomingByte == EOP)
    {
      ended = true;
      break;
    } 
    else{
      data.concat(incomingByte);
    }
  }

  if(started && ended){
    started = false;
    ended = false;
    Serial.flush();
    return data;
  } 
  else {
    return "";
  }

}

boolean handleCommand(String request){ 
  String command = request.substring(0, 1);

  boolean valid = true;

  if(command == "S"){
    stopMovement();
  } 
  else if(command == "M"){
    parseCoordinates(request.substring(2));
    move(x, y);
  } 
  else if(command == "D"){
    Serial.println("Distance");
  } 
  else if(command == "L"){
    switchLights();
  } 
  else if(command == "B"){
    beep(500);
  } 
  else {
    valid = false;
  }
  return valid;
}





