import bluetoothDesktop.*;

final String SERVICE_NAME = "Dev B";

Bluetooth bt;
Client server;
boolean connected = false;



String[] values = new String[2];


void setupBluetooth() {
  try {
    bt = new Bluetooth(this, 0x0003); // RFCOMM
    bt.find();
    println("searching...");
  } 
  catch (RuntimeException e) {
    println( "error. is your bluetooth on?");
    println(e);
    exit();
  }
}

void serviceDiscoveryCompleteEvent(Service[] s) {
  Service[] services = (Service[])s;

  println("Search completed.");

  // now search for the service we want
  for (int i=0; i<services.length; i++) {
    if (services[i].name.equals(SERVICE_NAME)) {
      //println("Service " + SERVICE_NAME + " found");

      try {
        // we found our service, so try to connect to it
        // if we try to connect to it more than once, this will throw an error.
        server = services[i].connect();
        println("Connected to service " + SERVICE_NAME + " on server " + server.device.name);
        connected = true;


        return;
      } 
      catch (Exception e) {
        println("Found service " + SERVICE_NAME + " on Server " + server.device.name + ", but connection failed: " + e.getMessage());
        return;
      }
    }
  }

  println("Service " + SERVICE_NAME + " not found.");
}


int b = 0;
int pos = 0;

boolean started = false;
boolean ended = false;

void btComm(String data) {
  server.write(data.getBytes());
}


String btRead() {
  byte[] r = new byte[200];

  b = 0;
  pos = 0;
  while (true) {
    b = server.read();

    if (b == '<')
    {
      started = true;
      ended = false;
    } 
    else if (b == '>') {
      ended = true;
      break;
    } 
    else {
      r[pos] = byte(b);
      pos++;
    }
  } 

  if (started && ended) {
    started = false;
    ended = false;
    return new String(r);
  } 
  else {
    return "";
  }
}


